      Program test

      implicit none

      integer N_iter
      parameter ( N_iter = 200 )
      integer Nmax
      parameter ( Nmax = 19 )
      real*8 phi(0:Nmax+1, 0:Nmax+1), phi_old(0:Nmax+1,0:Nmax+1),
     &       phi_sol(0:Nmax+1, 0:Nmax+1)
      logical modify_pt(0:Nmax+1, 0:Nmax+1) 

      integer mode
      real*8 pi
      real*8 delta, parm, parm_sq
      integer count, ii, jj

      integer istep, prev_istep, Nprint, icenter
      real*8 rtmp, sum

      pi = 4.0d0 * datan( 1.0d0 )
      write(6,*) 'pi = ', pi

      delta = 1.0d0 / ( Nmax + 1 )
      mode = 1
      parm  = delta * mode * pi
      parm_sq = parm * parm

c  Initialize the grid & Set up the boundary condition
      do jj = 0, Nmax+1
         do ii = 0, Nmax+1
            phi( ii, jj) = 0.0d0
            if ( ii .eq. 0 .or. jj .eq. Nmax+1 ) then
               modify_pt( ii, jj ) = .false.
            else
               modify_pt( ii, jj ) = .true.
            endif
         enddo
      enddo

c  Set up constant point potential
      icenter = ( Nmax + 1 ) / 2
      modify_pt( icenter, icenter ) = .false.
      phi( icenter, icenter ) = 99.0d0

c  Start the calculation
      Nprint = 10
      prev_istep = -1
      do count = 1, N_iter

         istep = count / Nprint
         if ( istep .gt. prev_istep ) then
            write(6,*)
            prev_istep = istep
            write(6,*) '****  count = ', count
 
            do ii = 1, Nmax
               write(6,10) ( int( phi(ii,jj) ), jj=1,Nmax )
            enddo
10          format(20(i4))

            sum = 0.0d0
            do jj = 0, Nmax+1
               do ii = 0, Nmax+1
               rtmp = phi( ii,jj ) - phi_old( ii,jj )
               sum = sum + rtmp * rtmp
               enddo
            enddo
            write(6,*) '****  sum of error = ', sum
c           pause
         endif

         do jj = 0, Nmax+1
            do ii = 0, Nmax+1
               phi_old( ii,jj ) = phi( ii,jj )
            enddo
         enddo

         do jj = 0, Nmax+1
            do ii = 0, Nmax+1
               if ( modify_pt( ii,jj ) ) then
                  phi( ii,jj )
     &            = ( phi_old( ii-1,jj ) + phi_old( ii+1,jj )
     &              + phi_old( ii,jj-1 ) + phi_old( ii,jj+1 ) )
     &            / 4.0d0
               endif
            enddo
         enddo

      enddo

      end         
